//+------------------------------------------------------------------+
//|                                                       eclock.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

extern color colorNormal = Gold;
extern color colorLate   = Red;
extern int   fontSize    = 10;
extern int   corner      = 3;
extern int   xPos        = 10;
extern int   yPos        = 10;

//
//
//
//
//

int      timeFrame;
bool     SetingUp;
datetime SavedTime;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SavedTime = EMPTY_VALUE;
   SetingUp  = false;
      while(true)
      {  
         ShowClock(); Sleep(250);  if (IsStopped()) { break; }
      }
   return(0);
}

//
//
//
//
//

int deinit()
{
   switch(UninitializeReason())
   {
      case REASON_CHARTCLOSE:
      case REASON_REMOVE:
               break;
      case REASON_RECOMPILE:
      case REASON_CHARTCHANGE:
      case REASON_PARAMETERS:
      case REASON_ACCOUNT:
               SavedTime = EMPTY_VALUE;
               break;
   }
   ObjectDelete("eclock");
   return(0);
}

//
//
//
//
//

int start()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ShowClock()
{
   int    theColor;
   string time;
 
   RefreshRates();
   int diff = MathRound((TimeCurrent()-TimeLocal())/3600.0)*3600;
         time = getTime(iTime(NULL,0,0)+Period()*60-TimeLocal()-diff,theColor);

         //
         //
         //
         //
         //
                  
         if(ObjectFind("eclock") != 0)
            ObjectCreate("eclock",OBJ_LABEL,0,0,0);
               ObjectSet("eclock",OBJPROP_CORNER,corner);
               ObjectSet("eclock",OBJPROP_XDISTANCE,xPos);
               ObjectSet("eclock",OBJPROP_YDISTANCE,yPos);
               ObjectSetText("eclock",time,fontSize, "Arial bold", theColor);
   WindowRedraw();
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

string getTime(int times,int& theColor)
{
   string time = "";
   int    seconds;
   int    minutes;
   int    hours;
   
   //
   //
   //
   //
   //
   
   if (times < 0) {
         theColor = colorLate; times = MathAbs(times);}
   else  theColor = colorNormal;
   seconds = (times%60);
   hours   = (times-times%3600)/3600;
   minutes = (times-seconds)/60-hours*60;

   //
   //
   //
   //
   //
   
   if (hours>0)
   if (minutes < 10)
         time = StringConcatenate(time,hours,":0");
   else  time = StringConcatenate(time,hours,":");
         time = StringConcatenate(time,minutes);
   if (seconds < 10)
         time = StringConcatenate(time,":0",seconds);
   else  time = StringConcatenate(time,":" ,seconds);
   return(time);
}